package com.qmrz.service.impl;

import com.github.pagehelper.PageHelper;
import com.qmrz.constants.AppConstant;
import com.qmrz.dto.PageMapDTO;
import com.qmrz.login.PoliceLogin;
import com.qmrz.service.${table_name2}Service;
import com.qmrz.service.XzqhService;
import com.qmrz.utils.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
* ${table_name}，${table_comment}
*/
@Slf4j
@Service
public class ${table_name2}ServiceImpl extends BaseServiceImpl implements ${table_name2}Service {
public ${table_name2}ServiceImpl() {
super("${table_name}");
}

@Autowired
XzqhService xzqhService;

public void export(Map where) {
//清除map value 为空
MapUtil.clearEmpty(where);

List<String> xzqhGrade5List = xzqhService.getGrade5CodeBy5Name(Fn.toString(where.get("like_xzqhname")));
if(!ConvertUtil.isEmpty(xzqhGrade5List)){
    where.put("where_xzqhGrade5List", xzqhGrade5List);
}

String statusList = Fn.clearNotInteger(Fn.toString(where.get("where_status")));
CheckUtil.isEmpty(statusList, "where_status参数有误");
where.put("where_status", statusList);

//数据权限限制
where.putAll(PoliceLogin.getWhereMap(Fn.toString(where.get("where_gldwsearch"))));
where.put("where_nowtime",DateTimeUtil.currentStr());
List<Map> dataList = dbHelper.selectList(getMapperName("getList"), where);

    if ("4".equals(statusList))
    dataList.forEach(i -> i.put("memoname", AppConstant.getMemoValue(Fn.toInt(i.get("memo")))));

    DateTimeUtil.formatByObj(dataList);

    Map<String, String> colMap = new LinkedHashMap<>();
    //===============TODO 待处理===============//
    //        colMap.put("ownername", "房东姓名");
    //        colMap.put("ownerphone", "联系电话");
    //        colMap.put("houseaddr", "房屋地址");
    //        colMap.put("housenumber", "房间号");
    //        colMap.put("xzqhname", "行政区划");
    //        colMap.put("gldwname", "管辖单位");
    //        colMap.put("peoplecount", "当前在住人数");
    //
    //        if ("1".equals(statusList)) {
    //            colMap.put("fppolicename", "分派人");
    //            colMap.put("jspolicename", "接收人");
    //            colMap.put("fptime", "分派时间");
    //        } else if (statusList.contains("2") || statusList.contains("3")) {
    //            colMap.put("chthpolicename", "撤回/退回人");
    //            colMap.put("chthtime", "撤回/退回时间");
    //        } else if ("4".equals(statusList)) {
    //            colMap.put("fkpolicename", "反馈人");
    //            colMap.put("fktime", "反馈时间");
    //            colMap.put("memoname", "反馈结果");
    //        }else if ("5".equals(statusList)) {
    //            colMap.put("wxclpolicename", "处理人");
    //            colMap.put("wxcltime", "处理时间");
    //            colMap.put("remarks", "处理意见");
    //        }

    try {
    ExportPOIUtils.start_download(Web.getResponse(), DateTimeUtil.format("yyyyMMddHHmmss"), dataList
    , colMap.values().toArray(new String[]{})
    , colMap.keySet().toArray(new String[]{})
    );
    } catch (IOException e) {
    e.printStackTrace();
    }
    }

    public PageData<Map> pageList(PageMapDTO where) {
        //清除map value 为空
        MapUtil.clearEmpty(where);

        List<String> xzqhGrade5List = xzqhService.getGrade5CodeBy5Name(Fn.toString(where.get("like_xzqhname")));
        if(!ConvertUtil.isEmpty(xzqhGrade5List)){
            where.put("where_xzqhGrade5List", xzqhGrade5List);
        }

        String statusList = Fn.clearNotInteger(Fn.toString(where.get("where_status")));
        CheckUtil.isEmpty(statusList, "where_status参数有误");
        where.put("where_status", statusList);

        //数据权限限制
        where.putAll(PoliceLogin.getWhereMap(Fn.toString(where.get("where_gldwsearch"))));
        where.put("where_nowtime",DateTimeUtil.currentStr());
        List<Map> result = PageHelper.startPage(where.getPageIndex(), where.getPageSize()).doSelectPage(
            () -> dbHelper.selectList(getMapperName("getList"), where)
            );
            if ("4".equals(statusList))
            result.forEach( i -> i.put("memoname", AppConstant.getMemoValue(Fn.toInt(i.get("memo")))));
            return PageData.newobj(result);
            }
            }
